<?php
$projectActive = $this->module()->isActive('project') || $this->environment()->getClient()->isMaster();;
$keyword       = \Keyword\Entity\Group::GROUP_TYPE_KEYWORD;
$reference     = \Keyword\Entity\Group::GROUP_TYPE_REFERENCE;
?>

<ul class="breadcrumb">
    <li><a href="<?= $this->url('root') ?>"><?= $this->icon('home') ?></a></li>
    <li><?= $this->translate('administration_module_title') ?></li>
    <li class="active"><?= $this->translate('keyword_nav_list') ?></li>
</ul>

<h1 class="page-title">
    <?= $this->icon('keyword') ?> <?= $this->translate('keyword_module_title') ?>
</h1>

<div class="row row-padding"
     ng-controller="keywordIndexController as self"
     ng-init="self.init(<?= $projectActive ? 'true' : 'false' ?>)">
    <div class="col-xs-12">
        <div class="panel">
            <div class="panel-heading">
                <?= $this->translate('keyword_nav_list') ?>

                <div class="panel-heading-right">
                    <?php if ($this->acl()->isAllowed('keyword:e:group:c')) : ?>
                        <div class="panel-heading-actions" tooltip="<?= $this->translate('keyword_nav_form') ?>">
                            <?= $this->icon('create', 'fa-fw pointer', ['title' => $this->translate('keyword_nav_form'), 'ng-click' => 'self.createGroup()']) ?>
                        </div>
                    <?php endif; ?>
                </div>
            </div>
            <div class="panel-body">
                <div class="row">
                    <div class="col-xs-12">

                        <ul class="nav nav-tabs separator">
                            <li class="active">
                                <a href="#keyword-tab"
                                   data-toggle="tab"
                                   ng-click="self.setGroupType('<?= $keyword ?>')">
                                    <?= $this->translate('keywords') ?>
                                </a>
                            </li>
                            <?php if ($projectActive): ?>
                                <li>
                                    <a href="#keyword-tab"
                                       data-toggle="tab"
                                       ng-click="self.setGroupType('<?= $reference ?>')">
                                        <?= $this->translate('keywords_reference') ?>
                                    </a>
                                </li>
                            <?php endif; ?>
                        </ul>

                        <div class="tab-content">
                            <div ng-class="{'fixed-table-wrapper': self.type === 'keyword'}"  class="tab-pane active" id="keyword-tab">
                                <table class="table table-bordered table-condensed table-hover">
                                    <thead>
                                        <tr>
                                            <th>
                                                <?= $this->translate('group_field_name') ?>
                                            </th>
                                            <?php
                                            foreach ($this->entities as $entity) {
                                                echo '<th class="fit-content" ng-show="self.type != \'' . $reference . '\'">';
                                                echo ucfirst($this->translate($entity['name'] . '_entity'));
                                                echo '</th>';
                                            }
                                            ?>
                                        </tr>
                                    </thead>
                                    <tbody>
                                        <tr ng-repeat-start="group in self.groups | filter : {type: self.type}">
                                            <td ng-style="group.open ? {'border-bottom-color':'#FEFEFE'} : null">
                                                <span class="pointer" ng-click="self.openGroup(group); group.open = !group.open">
                                                    <i class="fa" ng-class="{
                                                        'fa-folder-open': group.open,
                                                        'fa-folder': !group.open
                                                    }"></i>
                                                    {{group.name}}
                                                </span>

                                                <div class="btn-group btn-group-actions pull-right">
                                                    <?php if ($this->acl()->isAllowed('keyword:e:group:u')) : ?>
                                                        <a ng-if="group._rights.update" ng-click="self.createKeyword(group);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('keyword_nav_form') ?>">
                                                            <?= $this->icon('create') ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('keyword:e:group:r')) : ?>
                                                        <a ng-if="group._rights.read" ng-click="self.editGroup(group);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                                                            <?= $this->icon('edit') ?>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('keyword:e:group:u')) : ?>
                                                        <a ng-if="group._rights.update"
                                                           class="btn btn-xs btn-default"
                                                           tooltip="{{ !group.archived ? '<?= $this->translate('tooltip_archive') ?>' : '<?= $this->translate('tooltip_unarchive') ?>' }}"
                                                           ng-click="self.archiveGroup(group)">
                                                            <span ng-if="!group.archived">
                                                                <?= $this->icon('archive') ?>
                                                            </span>
                                                            <span ng-if="group.archived">
                                                                <?= $this->icon('unarchive') ?>
                                                            </span>
                                                        </a>
                                                    <?php endif; ?>

                                                    <?php if ($this->acl()->isAllowed('keyword:e:group:d')) : ?>
                                                        <a ng-if="group._rights.delete" ng-click="self.deleteGroup(group);" href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
                                                            <?= $this->icon('delete') ?>
                                                        </a>
                                                    <?php endif; ?>
                                                </div>
                                            </td>
                                            <?php
                                            foreach ($this->entities as $entity) {
                                                echo '<td class="text-center" ng-show="self.type != \'' . $reference . '\'" ng-class="{success: group.entities.indexOf(\'' . $entity['name'] . '\') > -1}">';
                                                echo '<input type="checkbox" ng-disabled="!group._rights.update" value="' . $entity['name'] . '" ng-click="self.updateEntity(group,\'' . $entity['name'] . '\', true)" ng-checked="group.entities.indexOf(\'' . $entity['name'] . '\') > -1" />';
                                                echo '</td>';
                                            }
                                            ?>
                                        </tr>
                                        <tr ng-repeat-end ng-show="group.open">
                                            <td colspan="<?= sizeOf($this->entities) + 1 ?>">
                                                <div ng-if="group.loading" class="text-center">
                                                    <?= $this->icon('loading') ?>
                                                </div>

                                                <ul class="tree">
                                                    <ng-include src="'keyword-tree.html'" ng-repeat="keyword in group.keywords | orderBy: 'order'"></ng-include>
                                                </ul>
                                            </td>
                                        </tr>
                                    </tbody>
                                </table>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>

    <script type="text/ng-template" id="keyword-tree.html">
        <li>
            <span ng-if="keyword.children.length > 0">
                <i class="fa fa-folder-open"></i>
            </span>
            <a>{{ keyword.name }}</a>

            <div class="btn-group btn-group-actions">
                <?php if ($this->acl()->isAllowed('keyword:e:keyword:r')) : ?>
                    <a ng-if="keyword._rights.read" ng-click="self.editKeyword(keyword);" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_edit') ?>">
                        <?= $this->icon('edit') ?>
                    </a>
                <?php endif; ?>

                <?php if ($this->acl()->isAllowed('keyword:e:keyword:u')) : ?>
                    <a ng-if="keyword._rights.update"
                       class="btn btn-xs btn-default"
                       tooltip="{{ !keyword.archived ? '<?= $this->translate('tooltip_archive') ?>' : '<?= $this->translate('tooltip_unarchive') ?>' }}"
                       ng-click="self.archiveKeyword(keyword)">
                        <span ng-if="!keyword.archived">
                            <?= $this->icon('archive') ?>
                        </span>
                        <span ng-if="keyword.archived">
                            <?= $this->icon('unarchive') ?>
                        </span>
                    </a>
                <?php endif; ?>

                <?php if ($this->acl()->isAllowed('keyword:e:keyword:d')) : ?>
                    <a ng-if="keyword._rights.delete" ng-click="self.deleteKeyword(keyword);" href="" class="btn btn-xs btn-default" tooltip="<?= $this->translate('tooltip_delete') ?>">
                        <?= $this->icon('delete') ?>
                    </a>
                <?php endif; ?>

                <?php if ($this->acl()->isAllowed('keyword:e:keyword:d')) : ?>
                    <a ng-if="keyword._rights.delete" ng-click="self.showFusionModal(keyword)" class="btn btn-xs btn-default" tooltip="<?= $this->translate('fusion') ?>">
                        <?= $this->icon('fusion') ?>
                    </a>
                <?php endif ?>
            </div>
            <ul ng-include src="'keyword-tree.html'" ng-repeat="keyword in keyword.children | orderBy: 'order'"></ul>
        </li>
    </script>

    <div id="groupFormModal" class="modal fade">
        <div class="modal-dialog">
            <div class="modal-content">
                <form name="groupForm" ng-submit="self.saveGroup(self.editedGroup);">
                    <div class="modal-header">
                        {{self.panelTitle}}
                    </div>
                    <div class="modal-body">
                        <input type="hidden" name="id"
                               ng-model="self.editedGroup.id"/>

                        <div class="row">
                            <div class="form-group col-xs-12">
                                <label>
                                    <?= $this->translate('group_field_multiple') ?> ?
                                    <input type="checkbox" ng-disabled="!self.editedGroup._rights.update" ng-model="self.editedGroup.multiple"/>
                                </label>
                                <field-errors field="multiple" errors="self.editedGroup.errors.fields"></field-errors>
                            </div>

                            <div class="form-group required col-xs-12">
                                <label><?= $this->translate('group_field_name') ?></label>
                                <input type="text" name="name" class="form-control" autocomplete="off" required
                                       ng-model="self.editedGroup.name" ng-readonly="!self.editedGroup._rights.update"/>
                                <field-errors field="name" errors="self.editedGroup.errors.fields"></field-errors>
                            </div>

                            <div class="form-group col-xs-12" ng-show="self.editedGroup.type != '<?= $reference ?>'">
                                <?php
                                foreach ($this->entities as $entity) {
                                    echo '<label class="no-bold">';
                                    echo ucfirst($this->translate($entity['name'] . '_entity'));
                                    echo '&nbsp;&nbsp;<input type="checkbox" ng-disabled="!self.editedGroup._rights.update" value="' . $entity['name'] . '" ng-click="self.updateEntity(self.editedGroup, \'' . $entity['name'] . '\', false)" ng-checked="self.editedGroup.entities.indexOf(\'' . $entity['name'] . '\') > -1" />';
                                    echo '</label>&nbsp;&nbsp;&nbsp;&nbsp;';
                                }
                                ?>

                                <field-errors field="entities" errors="self.editedGroup.errors.fields"></field-errors>
                            </div>
                        </div>
                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-default" type="button" data-dismiss="modal">
                            <?= $this->translate('close') ?>
                        </button>
                        <button class="btn btn-submit" ng-disabled="self.loading.save || !self.editedGroup._rights.update">
                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                            <?= $this->translate('save') ?>
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <div id="keywordFormModal" class="modal fade">
        <div class="modal-dialog">
            <div class="modal-content">
                <form name="keywordForm" ng-submit="self.saveKeyword(self.editedKeyword);">
                    <div class="modal-header">
                        {{self.panelTitle}}
                    </div>
                    <div class="modal-body">
                        <input type="hidden" name="id"
                               ng-model="self.editedKeyword.id"/>

                        <div class="row">
                            <div class="form-group required col-xs-12">
                                <label><?= $this->translate('keyword_field_name') ?></label>
                                <input type="text" name="name" class="form-control" autocomplete="off" required
                                       ng-model="self.editedKeyword.name" ng-readonly="!self.editedKeyword._rights.update"/>
                                <field-errors field="name" errors="self.editedKeyword.errors.fields"></field-errors>
                            </div>
                        </div>

                        <div class="row">
                            <div class="form-group col-xs-12">
                                <label><?= $this->translate('keyword_field_description') ?></label>
                                <textarea class="form-control" autocomplete="off" ng-model="self.editedKeyword.description" ng-readonly="!self.editedKeyword._rights.update"></textarea>
                                <field-errors field="description" errors="self.editedKeyword.errors.fields"></field-errors>
                            </div>
                        </div>

                        <div class="row">
                            <div class="form-group col-xs-12">
                                <label><?= $this->translate('keyword_field_parents') ?></label>
                                <keyword-select ng-disabled="!self.editedKeyword._rights.update" ng-model="self.editedKeyword.parents" multiple="true" configuration="{
                                    service: {
                                        apiParams: {
                                            search: {
                                                data: {
                                                    filters: {
                                                        id: {
                                                            op: 'neq',
                                                            val: self.editedKeyword.id
                                                        },
                                                        group: {
                                                            op: 'eq',
                                                            val: self.editedKeyword.group.id
                                                        }
                                                    }
                                                }
                                            }
                                        }
                                    }
                                }"></keyword-select>
                                <field-errors field="parents" errors="self.editedKeyword.errors.fields"></field-errors>
                            </div>
                        </div>

                        <div class="row">
                            <div class="form-group required col-xs-12">
                                <label><?= $this->translate('keyword_field_order') ?></label>
                                <input type="text" class="form-control" autocomplete="off" ng-model="self.editedKeyword.order" required ng-readonly="!self.editedKeyword._rights.update"/>
                                <field-errors field="order" errors="self.editedKeyword.errors.fields"></field-errors>
                            </div>
                        </div>

                    </div>
                    <div class="modal-footer">
                        <button class="btn btn-default" type="button" data-dismiss="modal">
                            <?= $this->translate('close') ?>
                        </button>
                        <button class="btn btn-submit" ng-disabled="self.loading.save || !self.editedKeyword._rights.update">
                            <?= $this->icon('loading', '', ['ng-if' => 'self.loading.save']) ?>
                            <?= $this->translate('save') ?>
                        </button>
                    </div>
                </form>
            </div>
        </div>
    </div>

    <div class="modal" id="fusionModal">
        <div class="modal-dialog">
            <div class="modal-content">
                <div class="modal-header">
                    <h4 class="modal-title"><?= $this->translate('keyword_fusion_title') ?></h4>
                </div>
                <div class="modal-body">
                    <div class="row" style="margin-bottom: 10px;">
                        <div class="col-xs-12">
                            <div class="form-group">
                                <label>
                                    <?= $this->translate('fusion_field_keywordToFusion') ?> :
                                </label>
                                {{ self.fusion.keywordToFusion.group.name }} - {{ self.fusion.keywordToFusion.name }}
                            </div>
                            <div class="form-group">
                                <label style="display: block;">
                                    <?= $this->translate('fusion_field_type') ?>
                                </label>
                                <label style="font-weight: normal;">
                                    <input ng-model="self.fusion.type"
                                           value="duplicate"
                                           type="radio">
                                    Dupliquer
                                </label>
                                <label style="margin-left: 5px; font-weight: normal;">
                                    <input ng-model="self.fusion.type"
                                           value="transfer"
                                           type="radio">
                                    Transférer
                                </label>
                            </div>
                            <div class="form-group">
                                <label for="fusion.keywordToKeep">
                                    <?= $this->translate('fusion_field_keywordToKeep') ?>
                                </label>
                                <keyword-select
                                    ng-model="self.fusion.keywordToKeep"
                                    configuration="{
                                        service : {
                                            apiParams: {
                                                col: ['id', 'name', 'description', 'parents.id', 'order', 'group.id', 'group.name'],
                                            }
                                        }
                                    }">
                                </keyword-select>
                            </div>
                        </div>
                    </div>
                </div>
                <div class="modal-footer">
                    <button class="btn btn-default" type="button" data-dismiss="modal">
                        <?= $this->translate('close') ?>
                    </button>

                    <button class="btn btn-submit" ng-disabled="self.loading.fusion"
                            ng-click="self.doFusion()">
                        <?= $this->icon('loading', '', ['ng-if' => 'self.loading.fusion']) ?>
                        <?= $this->translate('fusion') ?>
                    </button>
                </div>
            </div>
        </div>
    </div>
</div>
<?php
$fabLinks = [];
$fabLinks[] = [
    'href' => $this->url('import', ['entity' => 'keyword'], ['query' => ['type' => 'keyword']]),
    'text' => $this->icon('import', 'fa-fw') . ' ' . $this->translate('keyword_nav_import'),
];
$fabLinks[] = [
    'href' => $this->url('import', ['entity' => 'keyword'], ['query' => ['type' => 'reference']]),
    'text' => $this->icon('import', 'fa-fw') . ' ' . $this->translate('referential_nav_import'),
];
echo $this->fabMenu($fabLinks);
?>

<?php
$this->angular('js/src/keyword/controller/index.js');
$this->angular('js/src/keyword/directive/keywordSelect.js');
$this->angular('js/src/keyword/service/group.js');
$this->angular('js/src/keyword/service/keyword.js');
?>
